\ For ZCPR3 and ZDE 1.6 editor only
\ Pavel Zampach, 2021
\ *

zenv [IF]
decimal
system

\ Append string [addr2 u2] to string [addr1 u1].
: APPS   ( addr1 u1 addr2 u2 -- addr1 u1+u2 )
  2swap +string
;

0 value FID
variable CNT

: FC   ( ior -- )
  abort" file access error"
;

\ Project filename [addr u] (token or System file 4)
: PRONAME   ( -- addr u )
  token ?dup if
    2dup upper
    s" F" +ext
  else
    drop
    zenv 115 + 8 -trailing >pad		\ System file 4
    s" ." apps
    zenv 123 + 3 -trailing apps
  then
;

\ if line will be displayed, [flag] is true
defer PRINT?   ( -- flag )

: (VIEW)   ( -- )
  cnt off   cr
  proname r/o open-file fc to fid
  begin
    pad $168 c@ fid read-line fc	\ read line max. screen width
  while
    print? if
      pad swap type cr			\ display line
      1 cnt +!				\ inc line counter
      cnt @ $169 c@ 1- = if		\ lines of screen - 1
        ." SPACE cont, other end"
        key bl <> if
          fid close-file fc
        end
        13 emit 25 spaces 13 emit	\ clear message line
        cnt off
      then
    else
      drop
    then
  repeat   drop
  fid close-file fc
;

\ [flag] is TRUE if line begins with ": " or "CO"
: HEAD?   ( -- flag )
  pad @ $203a =				\ ": "
  pad @ $dfdf and $4f43 = or		\ "CO"
;

\ ---------- Interface ----------

\ - poke LOADLINE into ZCPR user area for use in ZDE via ^QQ command
\ - clear and prepare command line calling ZDE with project filename
\   and return to Forth
\ Revise pathes to ZDE and DX-Forth!
: EDIT   ( ["filename[.F]"] -- )
  loadline @ ?dup if			\ error line#
    zenv 34 + @ 64 + !			\ write it to user area
  then

  zenv 24 + @				\ addr of command line buffer
  dup 4 + dup rot !			\ write addr of the first char
  0					\ command line as empty string
  s" D1:ZDE " apps			\ add ZDE calling
  proname apps				\ add project filename
  s" ;D3:FZ" apps			\ add return to DX-Forth (D3:FZ.COM)
  + off					\ add trailing null
  bye
;

\ Include project file
: MAKE   ( ["filename[.F]"] -- )
  proname included
;

\ Display project file
: VIEW   ( ["filename[.F]"] -- )
  ['] true is print?
  (view)
;

\ List definition headers from project file
: HEAD   ( ["filename[.F]"] -- )
  ['] head? is print?
  (view)
;

\ Secure include of library
: INLIB   ( "name" -- )
  token pad pack
  find nip 0= if
    pad count 2dup upper
    2dup cr type ." \20loading"
    included
  then
;
application

behead apps head?

\ Must be done manually:
\ loadline off
\ save FZ.COM

[ELSE]
cr ." Z-System required!"
[THEN]
